

!!! Listing 1

!!! im Kopf: Wo die TagLib sich befindet

<?xml version="1.0" encoding="ISO-8859-1" ?>
<!DOCTYPE web-app
          PUBLIC "-//Sun Microsystems, Inc.//DTD Web Application 2.2//EN"
          "http://java.sun.com/j2ee/dtds/web-app_2.2.dtd">
<web-app>
  <display-name>Web Development with JSP</display-name>

  <servlet>
    <servlet-name>JspInit</servlet-name>
    <servlet-class>de.ix.jspTutorial.controller.JspTutorialStartServlet</servlet-class>
    <load-on-startup>1<load-on-startup>
  </servlet>

  <taglib>
    <taglib-uri>/ixtaglib</taglib-uri>
    <taglib-location>/WEB-INF/tlds/ixtaglib_1_0.tld</taglib-location>
  </taglib>
</web-app>

!!! Listing 2

!!! im Kopf: Tag Library Descriptor (Auszug)

<?xml version="1.0" encoding="ISO-8859-1" ?>
<!DOCTYPE taglib
        PUBLIC "-//Sun Microsystems, Inc.//DTD JSP Tag Library 1.1//EN"
        "http://java.sun.com/j2ee/dtds/web-jsptaglibrary_1_1.dtd">

<taglib>
    <tlibversion>1.0</tlibversion>
    <jspversion>1.1</jspversion>
    <shortname>jsptut</shortname>
    <info>Utility Tags for JSP.</info>
    
	  <tag>
	     <name>currency</name>
	     <tagclass>de.ix.jspTutorial.taglib.FormatCurrency</tagclass>
	     <bodycontent>EMPTY</bodycontent>
             <info>Simple German money formatter</info>
	     <attribute>
	       <name>value</name>
	       <required>true</required>
	       <rtexprvalue>true</rtexprvalue>
	     </attribute>
	  </tag>
          <!-- weitere Tags --> 
</taglib>

!!! Listing 3

!!! im Kopf: <I>currency<I>

package de.ix.jspTutorial.taglib;

import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import java.io.* ;
import java.util.* ;
import java.text.* ;

public class FormatCurrency extends BodyTagSupport
{
   private double myValue;	 
   private DecimalFormat myFormat ;
   
   public FormatCurrency()
   {
   			myFormat = new DecimalFormat();
		 		myFormat.setGroupingUsed(true);
		 		myFormat.setMinimumFractionDigits(2);
	  		myFormat.setMaximumFractionDigits(2);
   }
  
  public double getValue() { return myValue ; }
  
	public void setValue(String aValue)
	{
		this.myValue = new Double(aValue).doubleValue();
	}

	public void setValue(double aValue)
	{
		this.myValue = (double) aValue;
	}

	public void setValue(Double aValue)
	{
		this.myValue = (double) aValue.doubleValue();
	}
	
	public int doAfterBody()
		throws JspException
	{
		try
		{
		  getPreviousOut().print(formatCurrency(myValue)) ;
		}
		catch(java.io.IOException e)
		{
			throw new JspException("IO Error: " + e.getMessage());
		}

	    return SKIP_BODY;
  }
	
  protected  String formatCurrency(double aCurrencyValue) {
    return myFormat.format(aCurrencyValue) ;

	}
}

!!! Listing 4

!!! im Kopf: <I>currency<I> Tag aus <I>choice.jsp<I>

...
/* ----  jsptut:currency ---- */
de.ix.jspTutorial.taglib.FormatCurrency _jspx_th_jsptut_currency_2 = 
	new de.ix.jspTutorial.taglib.FormatCurrency();
_jspx_th_jsptut_currency_2.setPageContext(pageContext);
_jspx_th_jsptut_currency_2.setParent(_jspx_th_jsptut_foreach_2);
_jspx_th_jsptut_currency_2.setValue(pizza.getBasePrice());
try {
  int _jspx_eval_jsptut_currency_2 = _jspx_th_jsptut_currency_2.doStartTag();
  if (_jspx_eval_jsptut_currency_2 == Tag.EVAL_BODY_INCLUDE)
    throw new JspTagException(
     "Since tag handler class de.ix.jspTutorial.taglib.FormatCurrency implements BodyTag, it can't return Tag.EVAL_BODY_INCLUDE");
  if (_jspx_eval_jsptut_currency_2 != Tag.SKIP_BODY) {
    try {
      if (_jspx_eval_jsptut_currency_2 != Tag.EVAL_BODY_INCLUDE) {
        out = pageContext.pushBody();
        _jspx_th_jsptut_currency_2.setBodyContent((BodyContent) out);
      }
      _jspx_th_jsptut_currency_2.doInitBody();
      do {
      } while (_jspx_th_jsptut_currency_2.doAfterBody() == BodyTag.EVAL_BODY_TAG);
    } finally {
      if (_jspx_eval_jsptut_currency_2 != Tag.EVAL_BODY_INCLUDE)
        out = pageContext.popBody();
    }
  }
  if (_jspx_th_jsptut_currency_2.doEndTag() == Tag.SKIP_PAGE)
    return;
} finally {
  _jspx_th_jsptut_currency_2.release();
}
...

!!! Listing 5

!!! im Kopf: <I>foreach<I>-Durchlauf

...
<jsptut:foreach item="Pizza"  list="<%= pizzaList.getPizzas() %>" >
 <%     
     Pizza pizza = (Pizza)pageContext.findAttribute("Pizza"); 
  %>
  <TR>
    <TD><FONT FACE="Arial,Helvetica" SIZE="2">&nbsp;
        <jsp:getProperty name="Pizza" property="name" /></TD>
    <TD><FONT FACE="Arial,Helvetica" SIZE="2">&nbsp;
        <jsp:getProperty name="Pizza" property="size" /></TD>
    <TD><FONT FACE="Arial,Helvetica" SIZE="2">&nbsp;DM&nbsp;
        <jsptut:currency value="<%=pizza.getBasePrice()%>"/></TD>
    <TD><FONT FACE="Arial,Helvetica" SIZE="2">
        <INPUT NAME="ID_PIZZA" TYPE="radio" 
          VALUE="<jsp:getProperty name="Pizza" property="id" />"></TD>
  </TR>
</jsptut:foreach>
...

!!! Listing 6

!!! im Kopf: Bestellung: mittlere Thunfischpizza mit zwei Zutaten.

<?xml-version="1.0"?>

<!DOCTYPE Pizza-Online-Service [
		.
		.
		.
]>

<Pizza-Online-Service>
    <Order>
	 <Personal-Pizza>
            <Name>Thunfisch</Name>
            <Size>mittel (22 cm)</Size>
            <Price>10.95 DM</Price>
            <List-of-Ingredients>
                <Ingredient>
                    <Name>Salami</Name>
                    <Price>1.25 DM</Price>
                </Ingredient>
		    <Ingredient>
			  <Name>Kse</Name>
                    <Price>0.95 DM</Price>
                </Ingredient>
            </List-of-Ingredients>
        </Personal-Pizza>
        <Price>13.15 DM</Price>
        <Customer>
            <Firstname>Martin</Firstname>
            <Lastname>Mustermann</Lastname>
            <Address1>Bergstr. 10</Address1>
            <Address2>2. Etage links</Address2>
            <Zip>12345</Zip>
            <Town>Bad Meingarten</Town>
            <EMail>Martin@Mustermann.de</EMail>
        </Customer>
    </Order>
</Pizza-Online-Service>

!!! Listing 7

!!! im Kopf: XML-Generierung fr <I>Customer<I>

/**
   * method to generate XML Element containing all
   * important <code>Customer</code> information
   *
   * @param  document XML Document, to create xml element
   * @return xml element containing XML representation of PersonalPizza
   */
public Element generateXML(Document document) {
Element customer = (Element) 
document.createElement(XML_CUSTOMER_TAG);

      Element firstname   = (Element) 
document.createElement(XML_FIRSTNAME_TAG);
      firstname.appendChild(document.createTextNode(this.getFirstname()));

      Element lastname    = (Element) 
document.createElement(XML_LASTNAME_TAG);
      lastname.appendChild(document.createTextNode(this.getLastname()));

      Element address1 	  = (Element) 
document.createElement(XML_ADDRESS1_TAG);
      address1.appendChild(document.createTextNode(this.getAddress1()));

      Element address2    = (Element) 
document.createElement(XML_ADDRESS2_TAG);
      address2.appendChild(document.createTextNode(this.getAddress2()));

      Element zip         = (Element) 
document.createElement(XML_ZIP_TAG);
      zip.appendChild(document.createTextNode(this.getZip()));

      Element town        = (Element) 
document.createElement(XML_TOWN_TAG);
      town.appendChild(document.createTextNode(this.getTown()));

      Element eMail       = (Element) 
document.createElement(XML_EMAIL_TAG);
      eMail.appendChild(document.createTextNode(this.getEMail()));

      customer.appendChild(firstname);
      customer.appendChild(lastname);
      customer.appendChild(address1);
      customer.appendChild(address2);
      customer.appendChild(zip);
      customer.appendChild(town);
      customer.appendChild(eMail);

      return customer;
}

!!! Listing 8

!!! im Kopf: XMLOrderBuilder

/**
   * Build a new DOM containing all important 
   * information of a given order
   * 
   * @param order order, to be represented
   * @return new DOM document
   */
  public Document createXMLOrder(Order order) {

    Document document = null;

    DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
    try {

      DocumentBuilder builder = factory.newDocumentBuilder();
      document = builder.newDocument();

      // add root element
      Element root = (Element) document.createElement(XML_ROOT_TAG);
      document.appendChild(root);

      // add order tag and all sub tags
      Element orderElement = order.generateXML(document);
      root.appendChild(orderElement);

    } catch (ParserConfigurationException ex) {
      // Fehlerbehandlung ...
    }

    return document;
  }

!!! Listing 9 (nur online)

!!! im Kopf: Generieren der XML Ausgabe

/**
  * create XML output string
  *
  * @param node     xml node
  * @param prefix   prefix for formatted output
  *
  */
 public String generateXMLString(Node node, String prefix) {

    StringBuffer xmlStr = new StringBuffer();

    switch (node.getNodeType()) {

      case Node.ELEMENT_NODE:
          String name = node.getNodeName();
          xmlStr.append(prefix + "<"+name);
          
    NamedNodeMap attributes = node.getAttributes();          
    if (attributes != null) {
            for (int i=0; i<attributes.getLength(); i++) {
              Node current = attributes.item(i);
              xmlStr.append(" "    + current.getNodeName()   +
                               "=\""  + current.getNodeValue()  +
                               "\"" );
            }
          }
          xmlStr.append(">\n");

          // recurse child subtree
          NodeList children = node.getChildNodes();
          if (children != null) {
            for (int i=0; i<children.getLength(); i++) {
              xmlStr.append(generateXMLString(children.item(i), 
                                               prefix + "    "));
            }
          }
          xmlStr.append(prefix + "</"+name+">\n");
        break;


      case Node.TEXT_NODE:
      case Node.CDATA_SECTION_NODE:
          xmlStr.append(prefix + node.getNodeValue().trim()+"\n");
        break;
			.
			.
			.
    }

    return xmlStr.toString();

 }   


!!! Listing 10 (nur online)

!!! im Kopf: E-Mail leicht gemacht   

/** 
  * send included mail 
  */ 
public void sendMail() {

    Properties props = new Properties();
    props.put("mail.smtp.host", this.getSmtpServer());
    Session session = Session.getDefaultInstance(props, null);
    session.setDebug(MAIL_DEBUG);

    try{
      Message           message       = new MimeMessage(session);
      MimeBodyPart      mimeBodyPart  = new MimeBodyPart();
      Multipart         multiPart     = new MimeMultipart();
      InternetAddress   addressFrom   = 
new InternetAddress(this.getSender());
      InternetAddress[] addressTo = {new InternetAddress(MAIL_RECIPIENT)};

      message.setFrom(addressFrom);
      message.setRecipients(Message.RecipientType.TO, addressTo);
      message.setSubject(this.getSubject());

      mimeBodyPart.setText(this.getMessageText());
      multiPart.addBodyPart(mimeBodyPart);

      Vector attachFiles = this.getAttachments();

      // attach files
     if (! attachFiles.isEmpty() ) {
		... 
     }

      message.setContent(multiPart);
      Transport.send(message);

    } catch(javax.mail.MessagingException ex){
      System.out.println("Messaging Fehler: " + ex);
    } catch(Exception ex) {
      System.out.println("General Exception: " + ex);
    }
 }


!!! Listing 11 (ins Heft)

!!! im Kopf: Neuer Order Workflow

   /**
    * Handler-method for order request. Saves the current order and
    * changes also the current customer if necessary.
    * 
    * Additional create XML order and send this to via eMail to
    * pizza online service. 
    * 
    * @param request Current httpRequest
    */
  public void handleOrderEvent(HttpServletRequest request) {
    
	...

    Order order =  pizzaAccessor.newOrder(newCustomer,personalPizza);

	...

    // create xml order
    XMLOrderBuilder xmlOrder = new XMLOrderBuilder();
    Document xmlDocument = xmlOrder.createXMLOrder(order);

    // mail order
    if (USE_EMAIL) {

	// set mail values like sender, message text, et cetera
	...      
      String messageText = xmlOrder.generateXMLString(
(Node)xmlDocument, "");

      MailHelper mailHelper = new MailHelper( sender,
                                              recipients,
                                              smtpServer,
                                              subject,
                                              messageText,
                                              attchFiles);
      mailHelper.sendMail();
    }

 }
